Note: This is a public test instance of Red Hat Bugzilla. The data contained within is a snapshot of the live data so any changes you make will not be reflected in the production Bugzilla. Email is disabled so feel free to test any aspect of the site that you want. File any problems you find or give feedback at bugzilla.redhat.com.
Bug 2094582 - Review Request: libmd - Library that provides message digest functions from BSD systems
Summary: Review Request: libmd - Library that provides message digest functions from B...
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Benson Muite
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks: 1742611
TreeView+ depends on / blocked
 
Reported: 2022-06-07 23:31 UTC by Robert Scheck
Modified: 2022-09-23 03:07 UTC (History)
4 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2022-09-19 00:19:33 UTC
Type: ---
Embargoed:
benson_muite: fedora-review+


Attachments (Terms of Use)

Description Robert Scheck 2022-06-07 23:31:40 UTC
Spec URL: https://labs.linuxnetz.de/bugzilla/libmd.spec
SRPM URL: https://labs.linuxnetz.de/bugzilla/libmd-1.0.4-1.src.rpm
Description: The libmd library provides a few message digest ("hash") functions, as found on various BSD systems, either on their libc or on a library with the same name, and with a compatible API.
Fedora Account System Username: robert

Note: This package is intended for all active Fedora and EPEL branches.

Comment 1 Benson Muite 2022-06-08 05:21:28 UTC
Thanks for this. Is it possible to make a build on Copr or Koji to check that it will work on supported architectures,  
x86_64, AArch64 and ARM-hfp https://docs.fedoraproject.org/en-US/packaging-guidelines/#_architecture_support

Comment 2 Robert Scheck 2022-06-08 07:33:12 UTC
Koji: https://koji.fedoraproject.org/koji/taskinfo?taskID=88014756

Comment 3 Benson Muite 2022-06-08 11:30:58 UTC
Seems good. Need to check functionality. Unofficial review:

Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: If your application is a C or C++ application you must list a
     BuildRequires against gcc, gcc-c++ or clang.
[x]: Header files in -devel subpackage, if present.
[x]: ldconfig not called in %post and %postun for Fedora 28 and later.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.
[x]: Development (unversioned) .so files in -devel subpackage, if present.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Unknown or generated", "BSD 3-Clause License", "[generated
     file]", "FSF Unlimited License (with License Retention) [generated
     file]", "FSF Unlimited License [generated file]", "GNU General Public
     License v2.0 or later [generated file]", "GNU General Public License
     v3.0 or later", "X11 License [generated file]", "GNU General Public
     License v2.0 or later", "*No copyright* Public domain", "BSD 2-Clause
     License", "FSF Unlimited License (with License Retention) GNU General
     Public License, Version 2", "FSF Unlimited License (with License
     Retention)", "*No copyright* Beerware License", "ISC License", "BSD
     2-clause NetBSD License BSD 2-Clause License". 18 files have unknown
     license. Detailed output of licensecheck in
     /home/FedoraPackaging/libmd/2094582-libmd/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[x]: If the package is under multiple licenses, the licensing breakdown
     must be documented in the spec.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 30720 bytes in 2 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package must not depend on deprecated() packages.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Fully versioned dependency in subpackages if applicable.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: The placement of pkgconfig(.pc) files are correct.
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Sources are verified with gpgverify first in %prep if upstream
     publishes signatures.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on debuginfo package(s).
     Note: There are rpmlint messages (see attachment).
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Cannot parse rpmlint output:


Rpmlint (debuginfo)
-------------------
Cannot parse rpmlint output:



Rpmlint (installed packages)
----------------------------
Cannot parse rpmlint output:


Source checksums
----------------
https://keys.openpgp.org/vks/v1/by-fingerprint/4F3E74F436050C10F5696574B972BF3EA4AE57A3 :
  CHECKSUM(SHA256) this package     : 56b3e6dc62d6de533d1a86621b3d3fe8f9523a83f2b19927a95cffb8b562150b
  CHECKSUM(SHA256) upstream package : 56b3e6dc62d6de533d1a86621b3d3fe8f9523a83f2b19927a95cffb8b562150b
https://libbsd.freedesktop.org/releases/libmd-1.0.4.tar.xz.asc :
  CHECKSUM(SHA256) this package     : 32deebe1cfab127ee69a3e8c8caf439e459b7cdcdd7535fe021cb485adc14057
  CHECKSUM(SHA256) upstream package : 32deebe1cfab127ee69a3e8c8caf439e459b7cdcdd7535fe021cb485adc14057
https://libbsd.freedesktop.org/releases/libmd-1.0.4.tar.xz :
  CHECKSUM(SHA256) this package     : f51c921042e34beddeded4b75557656559cf5b1f2448033b4c1eec11c07e530f
  CHECKSUM(SHA256) upstream package : f51c921042e34beddeded4b75557656559cf5b1f2448033b4c1eec11c07e530f


Requires
--------
libmd (rpmlib, GLIBC filtered):
    libc.so.6()(64bit)
    rtld(GNU_HASH)

libmd-devel (rpmlib, GLIBC filtered):
    /usr/bin/pkg-config
    libmd(x86-64)
    libmd.so.0()(64bit)
    pkgconfig

libmd-debuginfo (rpmlib, GLIBC filtered):

libmd-debugsource (rpmlib, GLIBC filtered):



Provides
--------
libmd:
    libmd
    libmd(x86-64)
    libmd.so.0()(64bit)
    libmd.so.0(LIBMD_0.0)(64bit)

libmd-devel:
    libmd-devel
    libmd-devel(x86-64)
    pkgconfig(libmd)

libmd-debuginfo:
    debuginfo(build-id)
    libmd-debuginfo
    libmd-debuginfo(x86-64)
    libmd.so.0.0.5-1.0.4-1.fc37.x86_64.debug()(64bit)

libmd-debugsource:
    libmd-debugsource
    libmd-debugsource(x86-64)



Generated by fedora-review 0.8.0 (e988316) last change: 2022-04-07
Command line :/usr/bin/fedora-review -b 2094582
Buildroot used: fedora-rawhide-x86_64
Active plugins: C/C++, Generic, Shell-api
Disabled plugins: Python, fonts, Perl, Haskell, Ocaml, Java, SugarActivity, PHP, R
Disabled flags: EPEL6, EPEL7, DISTTAG, BATCH, EXARCH

Comment 4 Robert Scheck 2022-06-08 12:09:43 UTC
(In reply to Benson Muite from comment #3)
> Seems good. Need to check functionality. Unofficial review:

You are not a Fedora packager, has my FAS lookup been correct?

Comment 6 Benson Muite 2022-08-23 10:40:50 UTC
Can now approve.

Comment 7 Benson Muite 2022-08-24 09:54:10 UTC
Licensecheck.txt contains:

*No copyright* Beerware License
-------------------------------
libmd-1.0.4/man/md2.3
libmd-1.0.4/man/md4.3
libmd-1.0.4/man/md5.3
libmd-1.0.4/man/mdX.3
libmd-1.0.4/src/helper.c
libmd-1.0.4/src/md2hl.c
libmd-1.0.4/src/md4hl.c
libmd-1.0.4/src/md5hl.c
libmd-1.0.4/src/rmd160hl.c
libmd-1.0.4/src/sha1hl.c
libmd-1.0.4/src/sha256hl.c
libmd-1.0.4/src/sha384hl.c
libmd-1.0.4/src/sha512hl.c

*No copyright* Public domain
----------------------------
libmd-1.0.4/include/md4.h
libmd-1.0.4/include/md5.h
libmd-1.0.4/src/md4.c
libmd-1.0.4/src/md5.c

BSD 2-Clause License
--------------------
libmd-1.0.4/include/rmd160.h
libmd-1.0.4/src/rmd160.c

BSD 2-clause NetBSD License BSD 2-Clause License
------------------------------------------------
libmd-1.0.4/src/md2.c

BSD 3-Clause License
--------------------
libmd-1.0.4/COPYING
libmd-1.0.4/get-version
libmd-1.0.4/include/ripemd.h
libmd-1.0.4/include/sha.h
libmd-1.0.4/include/sha2.h
libmd-1.0.4/include/sha256.h
libmd-1.0.4/include/sha512.h
libmd-1.0.4/src/local-link.h
libmd-1.0.4/src/sha2.c
libmd-1.0.4/test/md2.c
libmd-1.0.4/test/md4.c
libmd-1.0.4/test/md5.c
libmd-1.0.4/test/rmd160.c
libmd-1.0.4/test/sha1.c
libmd-1.0.4/test/sha2.c
libmd-1.0.4/test/test.h

FSF Unlimited License (with License Retention)
----------------------------------------------
libmd-1.0.4/m4/ltoptions.m4
libmd-1.0.4/m4/ltsugar.m4
libmd-1.0.4/m4/ltversion.m4
libmd-1.0.4/m4/lt~obsolete.m4

FSF Unlimited License (with License Retention) GNU General Public License, Version 2
------------------------------------------------------------------------------------
libmd-1.0.4/m4/libtool.m4

FSF Unlimited License (with License Retention) [generated file]
---------------------------------------------------------------
libmd-1.0.4/aclocal.m4

FSF Unlimited License [generated file]
--------------------------------------
libmd-1.0.4/configure

GNU General Public License v2.0 or later
----------------------------------------
libmd-1.0.4/build-aux/ltmain.sh

GNU General Public License v2.0 or later [generated file]
---------------------------------------------------------
libmd-1.0.4/build-aux/ar-lib
libmd-1.0.4/build-aux/compile
libmd-1.0.4/build-aux/depcomp
libmd-1.0.4/build-aux/missing
libmd-1.0.4/build-aux/test-driver

GNU General Public License v3.0 or later
----------------------------------------
libmd-1.0.4/build-aux/config.guess
libmd-1.0.4/build-aux/config.sub

ISC License
-----------
libmd-1.0.4/man/rmd160.3
libmd-1.0.4/man/sha1.3
libmd-1.0.4/man/sha2.3

Public domain code seems to no longer be allowed, though want to check if this applies here. The spec could also be more descriptive in the license breakdown.

Comment 8 Robert Scheck 2022-08-24 11:38:25 UTC
(In reply to Benson Muite from comment #7)
> The spec could also be more descriptive in the license breakdown.

May I kindly ask you to explain this? The spec file says: "Breakdown in COPYING file of libmd release tarball". The mentioned COPYING file (online copy from git main branch to have it clickable in RHBZ: https://gitlab.freedesktop.org/libbsd/libmd/-/blob/main/COPYING) is very descriptive from my point of view; I've rarely seen an upstream being so precise about license per file, like here at libmd.

Comment 9 Benson Muite 2022-08-25 06:20:34 UTC
Minor point, but the FSF licensed files are not in COPYING.  Most other spec files also have the breakdown in them. What you have seems sufficient. Thanks for your contribution.

Comment 10 Robert Scheck 2022-09-12 18:54:06 UTC
> Public domain code seems to no longer be allowed

Benson, did I overlook something? At https://docs.fedoraproject.org/en-US/legal/allowed-licenses/, "Public Domain" is marked as allowed (for any use). Did you maybe mix up "CC0" (allowed-content) and "Public Domain" somehow?

> Minor point, but the FSF licensed files are not in COPYING.

Correct, but why should they? These files are not the actual software/code itself, just files generated by autoconf, automake, libtool et al. for the release tarball (like at many other projects).

Comment 11 Robert Scheck 2022-09-12 20:08:01 UTC
https://gitlab.com/fedora/legal/fedora-license-data/-/issues/70 was filed by Maxwell G after a discussion on the IRC (thanks!), who also suggested that "BSD and ISC and Beerware" should be switched to "BSD-2-Clause AND BSD-3-Clause AND ISC AND Beerware". I would postphone this until the clarification in the GitLab issue - and finally perform one change.

Comment 12 Benson Muite 2022-09-14 04:12:55 UTC
Thanks. For CC0 see
https://lists.fedoraproject.org/archives/list/legal@lists.fedoraproject.org/thread/RRYM3CLYJYW64VSQIXY6IF3TCDZGS6LM/#RRYM3CLYJYW64VSQIXY6IF3TCDZGS6LM

maybe md4.c, md5.c, md4.h and md5.h can be replaced with other implementations?

Comment 13 Maxwell G 2022-09-14 05:15:34 UTC
(In reply to Benson Muite from comment #12)
> Thanks. For CC0 see
> https://lists.fedoraproject.org/archives/list/legal@lists.fedoraproject.org/
> thread/RRYM3CLYJYW64VSQIXY6IF3TCDZGS6LM/#RRYM3CLYJYW64VSQIXY6IF3TCDZGS6LM
> 
> maybe md4.c, md5.c, md4.h and md5.h can be replaced with other
> implementations?

Why would they need to be replaced? They are *not* licensed under CC0, and Legal explicitly approved the package's license in the linked ticket.

Comment 14 Benson Muite 2022-09-14 05:45:13 UTC
Thanks for the update.  Can the spec file be update appropriately with the license information in the submitted package.

Comment 16 Benson Muite 2022-09-14 17:41:36 UTC
Approved. Have removed the legal block, hope that is ok.

Comment 17 Gwyn Ciesla 2022-09-14 18:02:47 UTC
(fedscm-admin):  The Pagure repository was created at https://src.fedoraproject.org/rpms/libmd

Comment 18 Fedora Update System 2022-09-14 20:01:03 UTC
FEDORA-2022-f13d8dc6db has been submitted as an update to Fedora 36. https://bodhi.fedoraproject.org/updates/FEDORA-2022-f13d8dc6db

Comment 19 Fedora Update System 2022-09-14 20:01:05 UTC
FEDORA-EPEL-2022-527b1fd790 has been submitted as an update to Fedora EPEL 7. https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2022-527b1fd790

Comment 20 Fedora Update System 2022-09-14 20:01:06 UTC
FEDORA-2022-54863c070a has been submitted as an update to Fedora 35. https://bodhi.fedoraproject.org/updates/FEDORA-2022-54863c070a

Comment 21 Fedora Update System 2022-09-14 20:01:07 UTC
FEDORA-EPEL-2022-0f15aae53d has been submitted as an update to Fedora EPEL 8. https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2022-0f15aae53d

Comment 22 Fedora Update System 2022-09-14 20:01:08 UTC
FEDORA-2022-00481ef4a1 has been submitted as an update to Fedora 37. https://bodhi.fedoraproject.org/updates/FEDORA-2022-00481ef4a1

Comment 23 Fedora Update System 2022-09-14 20:01:09 UTC
FEDORA-EPEL-2022-7a50056ac1 has been submitted as an update to Fedora EPEL 9. https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2022-7a50056ac1

Comment 24 Richard Fontana 2022-09-14 21:37:24 UTC
The presence of code covered by public domain dedications is probably not a problem but I haven't actually looked at the language here (public domain dedications are completely nonstandardized but are typically OK). Fedora does not allow CC0 for code as of ~2022-08-01 but I do not understand CC0 to be used in this package based on what has been reported here. 

Information on populating the spec file License: field can be found in Fedora Legal documentation but as far as I can gather from this bug those standards are being adhered to here.

Comment 25 Fedora Update System 2022-09-15 01:49:15 UTC
FEDORA-2022-00481ef4a1 has been pushed to the Fedora 37 testing repository.
Soon you'll be able to install the update with the following command:
`sudo dnf install --enablerepo=updates-testing --refresh --advisory=FEDORA-2022-00481ef4a1 \*`
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2022-00481ef4a1

See also https://fedoraproject.org/wiki/QA:Updates_Testing for more information on how to test updates.

Comment 26 Fedora Update System 2022-09-15 02:13:21 UTC
FEDORA-EPEL-2022-0f15aae53d has been pushed to the Fedora EPEL 8 testing repository.

You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2022-0f15aae53d

See also https://fedoraproject.org/wiki/QA:Updates_Testing for more information on how to test updates.

Comment 27 Fedora Update System 2022-09-15 02:13:46 UTC
FEDORA-EPEL-2022-7a50056ac1 has been pushed to the Fedora EPEL 9 testing repository.

You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2022-7a50056ac1

See also https://fedoraproject.org/wiki/QA:Updates_Testing for more information on how to test updates.

Comment 28 Fedora Update System 2022-09-15 02:21:42 UTC
FEDORA-2022-f13d8dc6db has been pushed to the Fedora 36 testing repository.
Soon you'll be able to install the update with the following command:
`sudo dnf install --enablerepo=updates-testing --refresh --advisory=FEDORA-2022-f13d8dc6db \*`
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2022-f13d8dc6db

See also https://fedoraproject.org/wiki/QA:Updates_Testing for more information on how to test updates.

Comment 29 Fedora Update System 2022-09-15 02:54:36 UTC
FEDORA-EPEL-2022-527b1fd790 has been pushed to the Fedora EPEL 7 testing repository.

You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2022-527b1fd790

See also https://fedoraproject.org/wiki/QA:Updates_Testing for more information on how to test updates.

Comment 30 Fedora Update System 2022-09-15 03:43:11 UTC
FEDORA-2022-54863c070a has been pushed to the Fedora 35 testing repository.
Soon you'll be able to install the update with the following command:
`sudo dnf install --enablerepo=updates-testing --refresh --advisory=FEDORA-2022-54863c070a \*`
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2022-54863c070a

See also https://fedoraproject.org/wiki/QA:Updates_Testing for more information on how to test updates.

Comment 31 Fedora Update System 2022-09-19 00:19:33 UTC
FEDORA-2022-00481ef4a1 has been pushed to the Fedora 37 stable repository.
If problem still persists, please make note of it in this bug report.

Comment 32 Fedora Update System 2022-09-23 00:31:45 UTC
FEDORA-EPEL-2022-7a50056ac1 has been pushed to the Fedora EPEL 9 stable repository.
If problem still persists, please make note of it in this bug report.

Comment 33 Fedora Update System 2022-09-23 00:42:08 UTC
FEDORA-EPEL-2022-0f15aae53d has been pushed to the Fedora EPEL 8 stable repository.
If problem still persists, please make note of it in this bug report.

Comment 34 Fedora Update System 2022-09-23 01:20:46 UTC
FEDORA-2022-f13d8dc6db has been pushed to the Fedora 36 stable repository.
If problem still persists, please make note of it in this bug report.

Comment 35 Fedora Update System 2022-09-23 02:53:24 UTC
FEDORA-EPEL-2022-527b1fd790 has been pushed to the Fedora EPEL 7 stable repository.
If problem still persists, please make note of it in this bug report.

Comment 36 Fedora Update System 2022-09-23 03:07:28 UTC
FEDORA-2022-54863c070a has been pushed to the Fedora 35 stable repository.
If problem still persists, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.